CovidConsult/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
import homepage.urls as homepage
import forum.urls as forum
import authentication.urls as authentication
import consultation.urls as consultation
import article.urls as article
import obatpedia.urls as obatpedia
import profilepage.urls as profilepage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(homepage)),
    path('forum/', include(forum)),
    path('accounts/', include(authentication)),
    path('article/',include(article)),
    path('consultation/', include(consultation)),
    path('obatpedia/', include(obatpedia)),
    path('apis/', include('apis.urls')), 
    path('profile/', include(profilepage))
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apis/urls.py
from django.urls import path

from .views import ListForum, DetailForum

urlpatterns = [
    path('forum/', ListForum.as_view()),
    path('forum/<int:pk>/', DetailForum.as_view()) 
]

article/urls.py
from django.urls import path
from .views import *
app_name = 'article'

app_name = 'article'

urlpatterns = [
    path('', index, name='article'),
    # TODO Add friends path using friend_list Views
    path('add',add_artikel),
    path('<int:id>',artikel_detail,name='artikel_detail'),
    path('rate',rate,name="rate-view"),
    path('search', search_results, name='search results'),
    path('getArtikelFlutter',getArtikelFlutter,name='getArtikelFlutter'),
    path('addArtikelFlutter',addArtikelFlutter,name='addArtikelFlutter'),
]

article/models.py
from django.db import models
from django.core.validators import MaxValueValidator,MinValueValidator
from django.utils.timezone import now


# Create your models here.
class Artikel(models.Model):
    penulis=models.CharField(max_length=30,default='anonymous')
    judul = models.CharField(max_length=200)
    isi = models.TextField(blank = True)
    datetime = models.DateTimeField(default=now)
    
    rating = models.IntegerField(default = 0,
        validators =[MaxValueValidator(5),MinValueValidator(0),]
        )

    def __str__(self):
        return self.judul

article/forms.py
from django import forms
from .models import Artikel


class ArtikelForm(forms.ModelForm):
    class Meta:
        model = Artikel
        fields = ['penulis','judul','isi']

article/views.py
from django.shortcuts import render
from rest_framework.serializers import Serializer
from .models import Artikel
from .forms import ArtikelForm
from django.contrib.auth.decorators import login_required
from django.shortcuts import get_object_or_404
from django.http import JsonResponse
from django.core import serializers
import json
from django.http.response import HttpResponse, HttpResponseRedirect
from django.views.decorators.csrf import csrf_exempt

# Create your views here.
def index(request):
    artikel = Artikel.objects.all()  # TODO Implement this
    response = {'artikel': artikel}
    return render(request, 'homeArtikel.html', response)

@login_required(login_url='/accounts/login')
def add_artikel(request):
    context = {}
    form = ArtikelForm(request.POST or None)
    if(request.method == 'POST') and (form.is_valid()):    
        form.save()
        return HttpResponseRedirect('/article')
        
    context['form'] = form
    return render(request, 'formArtikel.html', context)

@login_required(login_url='/accounts/login')
def artikel_detail(request, id):  # Untuk readmore
    artikel = get_object_or_404(Artikel,pk=id)
    response = {'artikel': artikel}
    return render(request, 'Artikel_details.html', response)

@login_required(login_url='/accounts/login')
def rate(request):
    if request.method == 'POST':
        el_id = request.POST.get('el_id')
        val = request.POST.get('val')
        obj = Artikel.objects.get(id=el_id)
        obj.rating = val
        obj.save()
        return JsonResponse({'success': 'true', 'rating': val}, safe=False)
    return JsonResponse({'success': 'false'})


def search_results(request):
    if request.is_ajax():
        result = None
        artikel = request.POST.get('artikel')
        qs = Artikel.objects.filter(judul__icontains=artikel)
        
        if len(qs) > 0:
            data = []
            for index in qs:
                item = {
                    'judul': index.judul,
                    'isi': index.isi,
                    'rating': index.rating,
                    'id':index.id,
                    'penulis':index.penulis,
                    'datetime':index.datetime
                    
                }
                data.append(item)
            result = data
        else:
            result = "No article  found."

        return JsonResponse({'data': result})
    return JsonResponse({})

def getArtikelFlutter(request):
    query = serializers.serialize('json',Artikel.objects.all())
    return HttpResponse(query,content_type="application/json")

@csrf_exempt
def addArtikelFlutter(request):
    if request.method == 'POST':
    
        data = json.loads(request.body)

        penulis_flutter = data["penulis"]
        judul_flutter = data["judul"]
        isi_flutter = data["isi"]

        Artikel_form = Artikel(penulis = penulis_flutter,judul = judul_flutter ,isi = isi_flutter)
        Artikel_form.save()

        return JsonResponse({"status": "success"}, status=200)
       
    else:
        return JsonResponse({"status": "error"}, status=401)

article/templates/Artikel_details.html
{% extends 'base.html' %}
{% load static %}


{% block meta %}
  <title>Article</title>    
  <link rel="stylesheet" href="{% static 'css/artikel.css' %}">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="http://code.jquery.com/jquery-3.4.1.min.js"></script>
<script src="http://code.jquery.com/ui/1.12.1/jquery-ui.min.js"> </script> 
{% endblock meta %}



{% block content %}
  <div style="margin-left:50px; padding-bottom: 20px; padding-top: 20px;">
      <a href="{% url 'article:article' %}" class="back">&lt Back to Article</a>
  </div>  
  <div class="form-article">
    <h1 style = "
      position : relative;  
      font-weight: bold;
      padding-bottom: 2px;
      text-align: center;
      text-decoration: underline;">
      {{artikel.judul}} </h1>
    <p style="text-align: right;">Post on {{artikel.datetime}}</p><br>
    <p style = "
      position : relative; 
      font-size: 20px; 
      padding-bottom: 2px;
      text-align: justify;"> 
      {{artikel.isi}}</p><br>
    <!-- <img src="{% static 'base/img/gitlabLogo.png' %}"width="55px" height="55px" > -->
    <p style="text-align: center;">Made by <b>{{artikel.penulis}}</b></p>
    <div class="col text-center">
      <form class="rate-form" action="" method="POST" id="{{artikel.id}}">
        {% csrf_token %}
        <button type="submit" class="fa fa-star fa-3x my-btn " id='first'></button>
        <button type="submit" class="fa fa-star fa-3x my-btn " id='second'></button>
        <button type="submit" class="fa fa-star fa-3x my-btn" id='third'></button>
        <button type="submit" class="fa fa-star fa-3x my-btn" id='fourth'></button>
        <button type="submit" class="fa fa-star fa-3x my-btn" id='fifth'></button>
      </form>
      <div id="confirm-box"></div>
    </div>
    <script src="{% static 'js/main.js' %}"></script>
  
  </div>
{% endblock content %}

article/templates/formArtikel.html
{% extends 'base.html' %}
{% load static %}


{% block meta %}
  <title>Add Article</title>    
  <link rel="stylesheet" href="{% static 'css/artikel.css' %}">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">

{% endblock meta %}

  {% block content %}
    <div class="form-article">
      <p style = "position : relative; 
      font-size: 20px; 
      font-weight: bold;
      padding-bottom: 2px;
      
      text-align: center;">
      Add New Article </p>
      <form action="" method="POST" >
          {% csrf_token %}
          <div class="form-section">
            <label for="penulis">Author Name</label><br>
            <input type="text" name="penulis" placeholder="type name here " maxlength="100" class="form-control add-form"> 
          </div>
          <div class="form-section">
              <label for="judul">Title</label><br>
              <input type="text" name="judul" placeholder="type title here" maxlength="100" class="form-control add-form"> 
          </div>
          <div class="form-section">
              <label for="isi">Article Content</label><br>
              <textarea name="isi" cols="40" rows="13" placeholder="type article here" class = "form-control add-form"></textarea>
          </div>
          
          <div class="form-section">
          <input type="submit" value="Post Article" class="submit-button"; style="position : relative;">
        
          </div>
      </form>
    </div>
  {% endblock content %}

article/templates/homeArtikel.html
{% extends 'base.html' %}
{% load static %}


{% block meta %}
  <title>Articles</title>    
  <link rel="stylesheet" href="{% static 'css/artikel.css' %}">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">
{% endblock meta %}


{% block content %}
  
  <div class="art">
    <h1 class="text-center display-4 fw-bold" style="color: #FFFFFF;">Articles</h1>
    <hr class="my-4" style="width: 10%; height: 3px; background-color: #FFFFFF; margin: auto">
    <div class="accordion" id="accordionExample" style="margin:0 10%">
      <div class="accordion-item btn-dark">
        <h2 class="accordion-header" id="headingOne">
          <button class="accordion-button " type="button" data-bs-toggle="collapse" data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne"  style="background-color: #131313; color: white;">
            What is an Article?
          </button>
        </h2>
        <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne" data-bs-parent="#accordionExample">
          <div class="accordion-body btn-dark" style="text-align: justify; ">
            <strong>An article</strong> is an essay that contains facts, opinions, or ideas that are made to be published in online media and conventional media. Articles must be written in a structured and systematic manner so that they are easy to read and understand. 
          </div>
        </div>
      </div>
      <div class="accordion-item btn-dark">
        <h2 class="accordion-header" id="headingTwo">
          <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo" style="background-color: #131313; color: white;">
            Article Function
          </button>
        </h2>
        <div id="collapseTwo" class="accordion-collapse collapse" aria-labelledby="headingTwo" data-bs-parent="#accordionExample">
          <div class="accordion-body btn-dark" style="text-align: left;">
            1. As a means to convey the author's ideas. <br>
            2. Train to think systematically. <br>
            3. Understand the purpose of writing. <br> 
            4. As a means of publishing the results of scientific thoughts. <br>
            5. Improve the author's insight. <br>
            6. Offers clarity. 
          </div>
        </div>
      </div>
      <div class="accordion-item btn-dark">
        <h2 class="accordion-header" id="headingThree">
          <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree" style="background-color: #131313; color: white;">
            How to Write Article?
          </button>
        </h2>
        <div id="collapseThree" class="accordion-collapse collapse" aria-labelledby="headingThree" data-bs-parent="#accordionExample">
          <div class="accordion-body btn-dark" style="text-align: left;">
            1. Forming your idea <br>
            2. Researching your idea <br>
            3. Outlining your idea <br>
            4. Writing your article <br>
            5. Finalizing your article
          </div>
        </div>
      </div>
    </div>
    <br><br>
    <h2> Search Article</h2><br>
    <h4> Gain more insights, tips about well-being,increase your idea and write yours. </h4>
  </div>
  <div class="cards-art" >
    
    <div class="cards-artL">
      <form class="d-flex" id="search_form">
        {% csrf_token %}
        <input class='form-control me-2' type="search" id="search_artikel" placeholder="type title here">
        
      </form>
      
    </div>
    <div class="cards-artR">
      <a href= "add">
        <button type="button" class="btn btn-secondary" style="background-color: #6B46C1;">
          Add new article</button></a>
    </div>
    <br>
    <div class="col-md-12" id="cards">
      {% if artikel %}
      {%for i in artikel%}
      <div class="cards">
          <div class="incards">
              <div class="incards-left">
              <h3>{{i.judul}}</h3>
              <p  class="demo"> {{i.isi}}</p>
              <a href="{% url 'article:artikel_detail' i.id %}" style="text-decoration: none;color:#744cc5 ;">Readmore →</a>
              </div>
              <div class="incards-right">
                  <p>Made by {{i.penulis}}</p>
                  <p>Post on {{i.datetime}}</p>
              </div>
          </div>    
      </div>
      {%endfor%}
      {% endif %}
    </div>
  </div>
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script>
    const url = window.location.href
    const searchForm = document.getElementById('search_form')
    const searchInput = document.getElementById('search_artikel')
    const cards = document.getElementById('cards')

    const csrf = document.getElementsByName('csrfmiddlewaretoken')[0].value
    console.log(csrf)

    $('form').submit(false);

    const sendSearchData = (artikel) => {
        $.ajax({
            type: 'POST',
            url: 'search',
            data: {
                'csrfmiddlewaretoken': csrf,
                'artikel': artikel,
            },
            success: (result) => {
                console.log(result.data)
                const data = result.data
                if (Array.isArray(data)) {
                    cards.innerHTML = ''
                    data.forEach(artikel => {
                        cards.innerHTML += `
                        <div class="cards">
                          <div class="incards">
                            <div class="incards-left">
                            <h3>${artikel.judul}</h3>
                            <p  class="demo"> ${artikel.isi}</p>
                            <a href="${artikel.id}" style="text-decoration: none;color:#744cc5 ;">Readmore →</a>
                            </div>
                            <div class="incards-right">
                              <p>Made by ${artikel.penulis}</p>
                              <p>Post on ${artikel.datetime}</p>
                            </div>
                          </div>    
                        </div>
                        `
                    })
                } else {
                    cards.innerHTML = `
                                        <b style="color: #FFFFFF">${data}</b>
                                        `
                }
            },
            error: (error) => {
                console.log(error)
            }
        })
    }
    searchInput.addEventListener('keyup', e=>{
        console.log(e.target.value)
        sendSearchData(e.target.value)
    })

  </script>

{% endblock content %}

   
    
    